/*
  MinesweeperCheat.c - Show the mines for Vista/7 Minesweeper.

  Jason Hood, 24 to 26 May, 2015.
*/

#define UNICODE
#define WIN32_LEAN_AND_MEAN
#define _WIN32_WINNT 0x600
#include <windows.h>


#define KEY_MINESWEEPER L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\GameUX\\Games\\{E91579C0-4EA9-4a2a-A9B2-04BEF1D6DC29}"
#define IDM_SHOW_MINES 40011


HWND  minesweeper;
HHOOK hook;


LRESULT CALLBACK HookProc( int nCode, WPARAM wParam, LPARAM lParam )
{
  static BOOL  down;
  static DWORD dtime;
  if (nCode == HC_ACTION)
  {
    PKBDLLHOOKSTRUCT kh = (PKBDLLHOOKSTRUCT)lParam;
    if ((kh->vkCode == VK_LCONTROL || kh->vkCode == VK_RCONTROL) &&
	GetForegroundWindow() == minesweeper)
    {
      if (!(kh->flags & LLKHF_UP))
      {
	if (!down)
	{
	  PostMessage( minesweeper, WM_COMMAND, IDM_SHOW_MINES, 0 );
	  dtime = kh->time;
	}
	down = TRUE;
      }
      else
      {
	if (kh->time - dtime > 250)
	  PostMessage( minesweeper, WM_COMMAND, IDM_SHOW_MINES, 0 );
	down = FALSE;
      }
    }
  }

  return CallNextHookEx( NULL, nCode, wParam, lParam );
}


DWORD WINAPI MessageThread( LPVOID lpParameter )
{
  MSG msg;

  hook = SetWindowsHookEx( WH_KEYBOARD_LL, HookProc, NULL, 0 );
  GetMessage( &msg, NULL, 0, 0 );

  return 0;
}


int WINAPI wWinMain( HINSTANCE hInst, HINSTANCE hPrev,
		     LPWSTR lpCmdLine, int nCmdShow )
{
  HWND	fg;
  HKEY	hKey;
  WCHAR exe[MAX_PATH];
  DWORD len;
  LONG	rc;
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  PVOID redir;

  rc = RegOpenKeyEx( HKEY_LOCAL_MACHINE, KEY_MINESWEEPER, 0,
		     KEY_READ | KEY_WOW64_64KEY, &hKey );
  if (rc != ERROR_SUCCESS)
  {
    MessageBox( NULL, L"Unable to locate Minesweeper.", L"Minesweeper Cheat",
		MB_OK );
    return 1;
  }
  len = sizeof(exe);
  RegGetValue( hKey, NULL, L"ConfigGDFBinaryPath", RRF_RT_REG_SZ,
	       NULL, exe, &len );
  RegCloseKey( hKey );

  ZeroMemory( &si, sizeof(si) );
  redir = NULL;
  Wow64DisableWow64FsRedirection( &redir );
  rc = CreateProcess( exe, NULL, NULL, NULL, FALSE, CREATE_UNICODE_ENVIRONMENT,
		      NULL, NULL, &si, &pi );
  Wow64RevertWow64FsRedirection( redir );
  if (!rc)
  {
    MessageBox( NULL, L"Unable to start Minesweeper.", L"Minesweeper Cheat",
		MB_OK );
    return 1;
  }
  CloseHandle( pi.hThread );

  fg = GetForegroundWindow();
  do
  {
    Sleep( 10 );
    minesweeper = GetForegroundWindow();
  } while (minesweeper == fg);

  CreateThread( NULL, 4096, MessageThread, NULL, 0, NULL );
  WaitForSingleObject( pi.hProcess, INFINITE );
  UnhookWindowsHookEx( hook );

  return 0;
}
